MageManaBar_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)

--local MMBmanapoolmultiplier, MMBtempmanapool, MMBmanaoverflow, MMBbloodelfracial

function MageManaBar_OnLoad(Frame) 
                                               
    if select(2, UnitClass("player")) ~= "MAGE" then MageManaBarBgFrame:Hide() return end
        
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
 	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
 	Frame:RegisterEvent("UNIT_MAXPOWER")
    
    if (MMBheightvar == nil) then MMBheightvar = 100 end 
    if (MMBwidthvar == nil) then MMBwidthvar = 300 end 
    if (MMBscalevar == nil) then MMBscalevar = 1 end
    if (MMBlevelvar == nil) then MMBlevelvar = 10 end
    if (MMBlockvar == nil) then MMBlockvar = true end
    
    MMBevocwarningcolor = 0
    MMBgemwarningcolor = 0
    MMBarcanewarningcolor = 0
    MMBevocationCDAnim = 0
    MMBmanaGemCDAnim = 0
    MMBArcaneTorrentCDAnim = 0
    MMBmanaGemFlash = 0
    MMBevocationFlash = 0
    MMBArcaneTorrentFlash = 0
    MMBmanaGemresize = 0
    MMBevocationresize = 0
    MMBArcaneTorrentresize = 0
    MMBtimers = true
    
end

-------------------------------
-- helper function for option panel setup
function MMBOptions_OnLoad(panel)
	panel.name = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- lock function for option panel
function MMBlock()

	if MMBlockButton:GetChecked(true) then MMBlockvar = true 
                                 MageManaBarBgFrame:EnableMouse(false)
                                 MMBlockButton:SetChecked(true)
                                 if (MMBchat==true) then ChatFrame1:AddMessage("|cff00ffffCombustionHelper locked|r") end
	else MMBlockvar = false 
         MageManaBarBgFrame:EnableMouse(true)
         MMBlockButton:SetChecked(false)
         if (MMBchat==true) then ChatFrame1:AddMessage("|cff00ffffCombustionHelper unlocked|r") end
	end
end

-------------------------------
-- Scale function for option panel
function MMBScale (scale)

    MMBscalevar = scale
	MageManaBarBgFrame:SetScale(scale)
end

-------------------------------
-- level function for option panel
function MMBlevel (level)

	MageManaBarBgFrame:SetFrameLevel(level)
	MMBlevelvar = level
end

-------------------------------
-- width function for option panel
function MMBwidth (width)

	MageManaBarBgFrame:SetWidth(width)
	MMBwidthvar = width
    MMBFrameResize()
end

-------------------------------
-- height function for option panel
function MMBheight (height)

	MageManaBarBgFrame:SetHeight(height)
	MMBheightvar = height
    MMBFrameResize()
end

MMBprefixtable = {"evocation","manaGem","ArcaneTorrent","mageArmor"}
                    
-------------------------------
-- Reset savedvariables function
function MMBFrameResize()

    MageManaBarBgFrame:SetWidth(MMBwidthvar)
    MageManaBarBgFrame:SetHeight(MMBheightvar)
    MageManaBarOverflowFrame:SetWidth(MMBwidthvar-2)
    MageManaBarOverflowFrame:SetHeight(MMBheightvar-2)
    MageManaBarFrame:SetWidth(MMBwidthvar-2)
    MageManaBarFrame:SetHeight(MMBheightvar-2)
    
    MMBwarningtext1:SetHeight((MMBheightvar/2)-2)
    MMBwarningtext2:SetHeight((MMBheightvar/2)-2)
--    MMBwarningtext1:SetStringHeight(30*(98/MMBheightvar))
--    MMBwarningtext2:SetStringHeight(30*(98/MMBheightvar))
    
    for i = 1,#MMBprefixtable do
        
        _G["MMB"..MMBprefixtable[i]]:SetHeight(MMBheightvar-2)
        _G["MMB"..MMBprefixtable[i].."gradred"]:SetHeight(MMBheightvar-2)
        _G["MMB"..MMBprefixtable[i].."gradblack"]:SetHeight(MMBheightvar-2)
        _G["MMB"..MMBprefixtable[i].."gradFrame"]:SetHeight(MMBheightvar-2)
    end
    
    MMBManabarMaxPool()
    MMBScale(MMBscalevar)
    MMBlevel(MMBlevelvar)
    
end

-------------------------------
-- Reset savedvariables function
function MMBreset()

    MMBheightvar = 100 
    MMBwidthvar = 300 
    MMBlevelvar = 10
    MMBscalevar = 1
    MMBlockvar = true
    MMBFrameResize()
    MageManaBarBgFrame:ClearAllPoints() 
    MageManaBarBgFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)
    
end
function MMBManabarUpdate()

	MageManaBarFrame:SetValue(UnitPower("player"))
	MageManaBarOverflowFrame:SetValue(UnitPower("player"))

end

function MMBManabarMaxPool()

    MMBmanapoolmultiplier = 1.05
    MMBtempmanapool = 0

	for i = 1,40 do
	
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", i)
		
		if (spellId == 79061) or (spellId == 79063) then
			MMBmanapoolmultiplier = 1.1
		elseif spellId then
			for z = 1,#MMBbufflist do
				if (spellId == (MMBbufflist[z])[2]) then
					MMBtempmanapool = MMBtempmanapool + (MMBbufflist[z])[3]
                    table.insert(MMBcurrentbuff,{expirationTime,name,duration,(MMBbufflist[z])[3]})
					break
				end
			end	
		else break
		end
	end
	
	if (#MMBcurrentbuff ~= 0) then
	
	    for i = #MMBcurrentbuff,1,-1 do
	        
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", (MMBcurrentbuff[i])[2])
	        if (name == nil) then
	            table.remove(MMBcurrentbuff,i)
	        end
	    end
	end
    
    MMBtempmanapool = (MMBtempmanapool * MMBmanapoolmultiplier)
    MMBregmanapool = UnitPowerMax("player")-MMBtempmanapool
	MageManaBarFrame:SetMinMaxValues(0,MMBregmanapool)
	MageManaBarOverflowFrame:SetWidth(MageManaBarFrame:GetWidth() * (UnitPowerMax("player")/MMBregmanapool ))
	MageManaBarOverflowFrame:SetMinMaxValues(0,UnitPowerMax("player"))
    
    MMBmanaGem:ClearAllPoints()
    MMBmanaGem:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*(12405/MMBregmanapool)),0)
    MMBevocation:ClearAllPoints()
    MMBevocation:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*0.6),0)
    MMBArcaneTorrent:ClearAllPoints()
    MMBArcaneTorrent:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*0.06),0)

end

function MMBmanaoverflowwarning()
	
    if (UnitPower("player") > (UnitPowerMax("player")-MMBtempmanapool)) then
    
    	for i = #MMBcurrentbuff,1,-1 do
    	
    		MMBmanaoverflow = UnitPower("player")-(UnitPowerMax("player")-MMBtempmanapool)
    		MMBbuffoverflowtimer = (MMBcurrentbuff[i])[1]-GetTime()
    		
    		if (MMBmanaoverflow > 0) then
		        MMBwarningtext1:SetText("MANA OVERFLOW !!")
        		MMBwarningtext2:SetText(format("%.0fmp lost in %.1f", MMBmanaoverflow, MMBbuffoverflowtimer))
        		MageManaBarBgFrame:SetWidth(MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player"))+2)
        		MMBoverflowflash("enable")
        		break
        	elseif ((MMBcurrentbuff[i])[4] <= MMBmanaoverflow) then
        		MMBmanaoverflow = MMBmanaoverflow - (MMBcurrentbuff[i])[4]
        	end
        end
        	
    else MMBwarningtext1:SetText("")
         MMBwarningtext2:SetText("")
         MMBoverflowflash("disable")
         MageManaBarBgFrame:SetWidth(MMBwidthvar)
    end
end

function MMBoverflowflash(command)
	
	if (command == "enable") then
		for i = 1,8 do
			_G["MMBFlash"..i]:Show()
		end
		
		MMBFlash2:SetWidth(MageManaBarBgFrame:GetWidth())
		MMBFlash6:SetWidth(MageManaBarBgFrame:GetWidth())
		MMBFlash4:SetHeight(MageManaBarBgFrame:GetHeight())
		MMBFlash8:SetHeight(MageManaBarBgFrame:GetHeight())
		
	elseif (command == "disable") and MMBFlash1:IsVisible() then
		for i = 1,8 do
			_G["MMBFlash"..i]:Hide()
		end
	end
end

function MMBSpellTimer(prefix,spellId)

    local start, duration, enable = GetSpellCooldown(spellId)
        
    if (duration > 1.55) and (_G["MMB"..prefix.."CDAnim"] == 0) then
        _G["MMB"..prefix.."Cooldown"]:SetCooldown(start,duration)
        _G["MMB"..prefix.."CDAnim"] = 1
    elseif (duration == 0) and (_G["MMB"..prefix.."CDAnim"] == 1) then
        _G["MMB"..prefix.."gradCooldown"]:SetCooldown(0,0)
        _G["MMB"..prefix.."CDAnim"] = 0
    end
    
    if (MMBtimers == true) and (duration > 1.55) then
        
        MMBspellCD = tonumber(format("%.0f",duration-(GetTime()-start)))
        local filename, fontHeight, flags = _G["MMB"..prefix.."Timer"]:GetFont()
        
        if (MMBspellCD == 0) then 
            _G["MMB"..prefix.."Timer"]:SetText("")
        elseif (MMBspellCD < 10) then
            if (_G["MMB"..prefix.."Flash"] < 3) then
                _G["MMB"..prefix.."Timer"]:SetText(format("|cffff0000%.0f|r",MMBspellCD))
                _G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
            elseif (_G["MMB"..prefix.."Flash"] < 6) then
                _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
                _G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
            else  _G["MMB"..prefix.."Flash"] = 1
            end
            if (_G["MMB"..prefix.."resize"] == 2) then 
            _G["MMB"..prefix.."Timer"]:SetFont(filename, fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.90, flags)
            _G["MMB"..prefix.."resize"] = 0
            end
        elseif (MMBspellCD <= 60) then
            _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
            if (_G["MMB"..prefix.."resize"] == 1) then 
                _G["MMB"..prefix.."Timer"]:SetFont(filename,fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.70,flags)
                _G["MMB"..prefix.."resize"] = 2
            end
        elseif (MMBspellCD > 60) then
            _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%d:%0.2d|r",MMBspellCD / 60, MMBspellCD % 60))
            if (_G["MMB"..prefix.."resize"] == 0) then 
                _G["MMB"..prefix.."Timer"]:SetFont(filename,fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.50,flags)
                _G["MMB"..prefix.."resize"] = 1
            end
        end
    end
    
    if (SpellId == 5405) and (GetItemCount(36799, false,true) == 0) then
        MMBmanaGemIcon:SetVertexColor(1,0,0,1)
    elseif (SpellId == 5405) and (GetItemCount(36799, false,true) ~= 0) then
        MMBmanaGemIcon:SetVertexColor(1,1,1,1)
    end
    
end

	
	
MMBcurrentbuff = {}
    
MMBbufflist = {
	
	{"Power Torrent", 74241, 7500},
	{"Volcanic Power", 79476, 18000},
	{"Volcanic Destruction", 89091, 24000},
	{"Lightweave", 75170, 8700},
	{"Lightweave", 55367, 4425},
	{"Synapse Springs", 82175, 7200}
}
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MageManaBar_OnEvent(self, event, ...)

    if (event == "PLAYER_LOGIN") then
    
        MMBFrameResize()
        
        if (MMBlockvar == true) then 
            MageManaBarBgFrame:EnableMouse(false)
        else MageManaBarBgFrame:EnableMouse(true)
        end
        
        MageManaBarFrame:SetStatusBarColor(0.2,0.5,0.8)
        MageManaBarOverflowFrame:SetStatusBarColor(1,0.3,0.3,0.5)
        
 		CreateFrame("Cooldown","MMBevocationCooldown",MMBevocationFrame)
		MMBevocationCooldown:SetAllPoints(MMBevocationFrame)
 		CreateFrame("Cooldown","MMBevocationgradCooldown",MMBevocationgradFrame)
		MMBevocationgradCooldown:SetAllPoints(MMBevocationgradFrame)
        CreateFrame("Cooldown","MMBmanaGemCooldown",MMBmanaGemFrame)
		MMBmanaGemCooldown:SetAllPoints(MMBmanaGemFrame)
        CreateFrame("Cooldown","MMBmanaGemgradCooldown",MMBmanaGemgradFrame)
		MMBmanaGemgradCooldown:SetAllPoints(MMBmanaGemgradFrame)
        CreateFrame("Cooldown","MMBmageArmorgradCooldown",MMBmageArmorgradFrame)
		MMBmageArmorgradCooldown:SetAllPoints(MMBmageArmorgradFrame)
        CreateFrame("Cooldown","MMBmageArmorCooldown",MMBmageArmorFrame)
		MMBmageArmorCooldown:SetAllPoints(MMBmageArmorFrame)
	    CreateFrame("Cooldown","MMBArcaneTorrentCooldown",MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown:SetAllPoints(MMBArcaneTorrentFrame)
	    CreateFrame("Cooldown","MMBArcaneTorrentgradCooldown",MMBArcaneTorrentgradFrame)
		MMBArcaneTorrentgradCooldown:SetAllPoints(MMBArcaneTorrentgradFrame)

        if (select(2, UnitRace("player")) == "Blood Elf") then
            MMBbloodelfracial = true
        else MMBbloodelfracial = false
            MMBArcaneTorrent:Hide()
        end 
        
    end
    
    if (event == "UNIT_MAXPOWER") then
    	
    	local unit, powertype = select(1, ...)
    	
    	if (unit == "player") then
    	
    		MMBManabarMaxPool()
    		
    	end
    end
    
    if (event=="COMBAT_LOG_EVENT_UNFILTERED") then

    	local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
            
            if (sourceName == UnitName("player")) then
            	
            	if (event == "SPELL_PERIODIC_ENERGIZE") and (spellId == 6117) then
            		MMBmageArmorgradCooldown:SetCooldown(0,0)
            		MMBmageArmorCooldown:SetCooldown(GetTime(),5)
            	end
            end
	end
    
end


	
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MageManaBar_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
 
		if (self.TimeSinceLastUpdate > MageManaBar_UpdateInterval) then
            
            MMBManabarUpdate()
            MMBmanaoverflowwarning()
            
 --[[           ------------------------------------- Evocation stuff
            local start, duration, enable = GetSpellCooldown(12051)
            
            if (duration <= 1.55) then
                if (MMBevocationCDanim == 1) then
                	MMBevocationgradCooldown:SetCooldown(0,0)
				end
				MMBevocationCDanim = 0
            elseif (MMBevocationCDanim == 0) then
				MMBevocationCooldown:SetCooldown(start, duration)
				MMBevocationCDanim = 1
            end
            
            if (UnitPower("player") < (MMBregmanapool*0.4)) and (duration <= 1.55) then
            	if (MMBevocwarningcolor >= 4) then
                    MMBevocationText:SetText(format("|cffff0000Evocation NOW !!|r"))
                    MMBevocwarningcolor = 0
                else MMBevocationText:SetText(format("|cffffff00Evocation NOW !!|r"))
                     MMBevocwarningcolor = MMBevocwarningcolor + 1
                end
            else MMBevocationText:SetText("")
            end
            
            ------------------------------------- Mana Gem stuff
            local start, duration, enable = GetSpellCooldown(5405)
            
            if (duration <= 1.55) then
                if (MMBmanaGemCDanim == 1) then
                	MMBmanaGemgradCooldown:SetCooldown(0,0)
				end
                MMBmanaGemCDanim = 0
            elseif (MMBmanaGemCDanim == 0) then
				MMBmanaGemCooldown:SetCooldown(start, duration)
				MMBmanaGemCDanim = 1
            end
            
            if (UnitPower("player") < (MMBregmanapool-12405)) and (duration <= 1.55) and (GetItemCount(36799, false,true) > 0) then
            	if (MMBgemwarningcolor >= 4) then
                    MMBmanaGemText:SetText(format("|cffff0000Use Gem NOW !!|r"))
                    MMBgemwarningcolor = 0
                else MMBmanaGemText:SetText(format("|cffffff00Use Gem NOW !!|r"))
                     MMBgemwarningcolor = MMBgemwarningcolor + 1
                end
            else MMBmanaGemText:SetText("")
            end
            
            ------------------------------------- Arcane Torrent stuff
            if (MMBbloodelfracial == true) then
	            local start, duration, enable = GetSpellCooldown(28730)
	            
	            if (duration <= 1.55) then
	                if (MMBArcaneTorrentCDanim == 1) then
	                	MMBArcaneTorrentgradCooldown:SetCooldown(0,0)
					end
	                MMBArcaneTorrentCDanim = 0
	            elseif (MMBArcaneTorrentCDanim == 0) then
					MMBArcaneTorrentCooldown:SetCooldown(start, duration)
					MMBArcaneTorrentCDanim = 1
	            end
	            
	            if (UnitPower("player") < (MMBregmanapool*0.94)) and (duration <= 1.55) then
	            	if (MMBarcanewarningcolor >= 4) then
	                    MMBArcaneTorrentText:SetText(format("|cffff0000Use Gem NOW !!|r"))
	                    MMBgemwarningcolor = 0
	                else MMBArcaneTorrentText:SetText(format("|cffffff00Use Gem NOW !!|r"))
	                     MMBarcanewarningcolor = MMBarcanewarningcolor + 1
	                end
	            else MMBArcaneTorrentText:SetText("")
	            end
	        end]]
            
            MMBSpellTimer("manaGem",5405)
            MMBSpellTimer("evocation",12051)
            MMBSpellTimer("evocation",28730)
            
            MMBArcaneTorrent:ClearAllPoints()
		    MMBArcaneTorrent:SetPoint("TOPLEFT",MageManaBarFrame,"TOPRIGHT", 0-(MageManaBarOverflowFrame:GetWidth()*0.06),0)
                        
            ------------------------------------- Mage Armor stuff
            
            MMBmageArmor:ClearAllPoints()
		    MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*0.03) + (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player"))),0)

            
   	    self.TimeSinceLastUpdate = 0

    end
end
